/****************************************************************************
**
**		    	Hitachi Character-Type LCD Display
**
****************************************************************************/

#include "p18f2455.h"
#include "lcd.h"
#include "iocfg.h"

/**  V A R I A B L E S   G L O B A L E S ***************************/
#pragma	udata

#pragma

const unsigned char const LCD_ROW_ADDRESS[] =	// Row/Column information for lcd_gotoxy()
{ 0x00 , 0x40 };

unsigned char z, deja;
unsigned int diz, tt, ttt;

//-------------------------------------------------------------
//Affiche nnn (16 bits) en char sur le lcd.
//N'affiche pas les zeros avant unites !
void Inttochar(unsigned int nnn) {

 deja = 0;

 //Compte les dix-Milliers
 diz = 10000;
 z = 0;
 while (nnn >= diz) {
   z++;
   nnn -= diz;
 }
 if ((z)||(deja)) {
   lcd_print('0'+z);
   deja = 1;
 }

 //Compte les Milliers
 diz = 1000;
 z = 0;
 while (nnn >= diz) {
   z++;
   nnn -= diz;
 }
 if ((z)||(deja)) {
   lcd_print('0'+z);
   deja = 1;
 }

 //Compte les centaines
 diz = 100;
 z = 0;
 while (nnn >= diz) {
   z++;
   nnn -= diz;
 }
 if ((z)||(deja)) {
   lcd_print('0'+z);
   deja = 1;
 }

 //Compte les Dizaines
 diz = 10;
 z = 0;
 while (nnn >= diz) {
   z++;
   nnn -= diz;
 }
 if ((z)||(deja))
   lcd_print('0' + z);

 //Compte les unites
 z = 0;
 while (nnn) {
   z++;
   nnn--;
 }
 lcd_print('0' + z);
}
//---------------------------------------------------------
//Pour 4_BIT_MODE (datas sur PORTB4-7 & LCDE=RB2)
void lcd_putnybble(unsigned char x) {	// Write nybble to port in current RS mode
unsigned char b;
    b = PORTB & 0x0F;
	PORTB = b + (x << 4);			// data
	LCD_E = 1;					// E = 1
	TempoUS(15);				// Beware of the dog !
	LCD_E = 0;					// Finish write cycle
	TempoUS(15);				// Beware of the dog !
}

void lcd_putbyte(unsigned char c) {		// Write byte to port in current RS mode
	lcd_putnybble(c >> 4);				// Send the character out
	lcd_putnybble(c);
}

void lcd_command(unsigned char c) {		// Send command to LCD port
	LCD_RS = 0;
	lcd_putbyte(c);
}
//---------------------------------------------------------
void lcd_print(unsigned char c) {		// Write character to LCD
	LCD_RS = 1;							//	Set to display mode
	lcd_putbyte(c);						//	Send character out
}
//---------------------------------------------------------
void lcd_printf(const far rom char *message) {
// Write message to LCD
//Passe les chr<32 et arrete sur '\0'.
unsigned char n,c;

  while (1) {

	while (1) {
	  c= *message++;
	  if (!c) return;					// sort si \0
	  if (c>31) break;					// next si <32
    }
    lcd_print(c);	
  }					//	Show char
}
//---------------------------------------------------------
void lcd_clear(void) {				// Clear LCD screen
	lcd_command(LCD_COMMAND_CLEAR);
	TempoMS(30);
	lcd_home();						// Home
}
void lcd_home(void) {				// Home
	lcd_command(0x03);
	TempoMS(10);
}
void lcd_line(unsigned char line) {	// change ligne
	lcd_command(0x80 | line);
	TempoMS(8);
}
void lcd_line2(void) {				// Sur ligne 2
	lcd_command(0xC0);
	TempoMS(8);
}
void lcd_init(void)	{				// Reset display from software
    LATB = 0;
	LCD_E = 0;						// Set up control pin I/O
	LCD_RS = 0;						// Command mode

	TempoMS(30);					// Wait a little while

	//mode 8bits au Reset
	lcd_putnybble(0x03);			// Select 4-bits mode
	TempoMS(30);					// Spec calls for 4.1 mS
	//mode 8bits au Reset
	lcd_putnybble(0x03);			// Select 4-bits mode
	TempoMS(30);					// Spec calls for 4.1 mS

	// Send again
	lcd_putnybble(0x03);			// Select 4-bits mode
	TempoMS(30);					// Spec calls for 4.1 mS
	//mode 8bits au Reset
	lcd_putnybble(0x02);			// Select 4-bits mode
	TempoMS(30);					// Spec calls for 4.1 mS

	lcd_command(0x0C);			// display on, no cursor
	TempoMS(30);

	lcd_command(0x06);			// mode set (increment)
	TempoMS(30);

	lcd_command(0x03);			// Home
	TempoMS(30);

	lcd_command(0x01);			// Clear
	TempoMS(30);
}
//------------------------------------------------------------
//Fait une tempo de x secondes (avec clk = 24MHz)
void TempoS(unsigned int sec) {

 for ( ; sec!=0; sec-- )
   for (ttt=1; ttt<99; ttt++)
     TempoMS(10);		// 1S
}

//Fait une tempo de x msecondes (avec clk = 24MHz)
void TempoMS(unsigned int nms) {

 for ( ; nms!=0; nms-- )
   for (tt=1; tt<372; tt++)
     Nop();		// 1mS
}

//Fait un peu plus que 1.5 uS
void TempoUS(unsigned int n) {
n /=2;
 while (n) {
   n--;
 }
}

//================================================================
