
#define	LCD_LINE1		0x00				// position ligne 1
#define	LCD_LINE2		0x40				// position ligne 2
#define	LCD_LINE3		0x10				// position ligne 3
#define	LCD_LINE4		0x50				// position ligne 4

#define	LCD_CURSOR_BLINK					// Blink/Noblink cursor mode
#define	LCD_CURSOR_ON						// Cursor visible
#define	LCD_CURSOR_INCREMENT				// Set left-to-right cursor movement
#define	LCD_CURSOR_SHIFT					// Shift display on entry

#define	LCD_DISPLAY_5x10					// Select 5x7 or 5x10 character matrix
#define	LCD_DISPLAY_ON						// Turn display on/off

//nb octets par char / barre avancement
#define BYTES_BLOC		( DEMI_FULL_RAM / (LCD_MAXCOLS-1) )

#define LCD_MAXROWS			4
#define	LCD_MAXCOLS			16
#define	LCD_MULTI_LINE		1

#define	LCD_COMMAND_CLEAR		0x01			// Clear screen, home cursor, unshift display
#define	LCD_COMMAND_HOME		0x02			// Home cursor, unshift display

// Local functions:

void Inttochar(unsigned int);
void lcd_welcome(void);
void lcd_init(void);							// Initialize LCD bus and Mode
void lcd_print(unsigned char c);				// Write character to LCD
void lcd_command(unsigned char c);				// Write command to LCD controller
void lcd_printf(const far rom char *message);	// Write message to LCD (C string type)
void lcd_clear(void);							// Clear LCD screen
void lcd_home(void);							// set Home screen
void lcd_line(unsigned char);					// set Ligne
void TempoS(unsigned int);
void TempoMS(unsigned int);
void TempoUS(unsigned int);
